<template>
    <dialog :id="modalData.id" class="modal">
        <div class="modal-box">
            <!-- form title -->
            <h3 class="font-bold text-lg" v-html="modalData.title"></h3>
            <!-- form text -->
            <p class="mt-4" v-if="modalData.text" v-html="modalData.text"></p>
            <hr v-if="modalData.fields && ((modalData.fields.length > 1) || (modalData.fields.length == 1 && modalData.fields[0].type !== 'hidden'))" class="my-4" />
            <!-- form -->
            <form @submit.prevent="emitEvent('onSubmit')">
                <!-- form fields -->    
                <div class="mb-4" v-for="(field, fieldIndex) in modalData.fields">
                    <label v-if="field.label" :key="field.id + '_lbl'" :for="field.id" class="block text-sm font-medium base-100" v-html="field.label"></label>
                    <input v-if="field.type !== 'textarea' && field.type !== 'select_textual' && field.type !== 'select_image'" :key="field.id + '_inp'" :type="field.type" :id="field.id" :placeholder="field.placeholder" :class="field.cssClass + ' mt-1 p-2 w-full rounded-md text-control'" style="color: #333; !important" :required="field.required" v-model="field.value" />
                    <textarea v-if="field.type === 'textarea'" :key="field.id + '_inp'" :id="field.id" :placeholder="field.placeholder" :class="field.cssClass + ' mt-1 p-2 w-full rounded-md'" :required="field.required" v-model="field.value" style="color: #333; !important; background: white !important;"></textarea>
                    
                    <select v-if="field.type === 'select_textual'" :key="field.id + '_sel'" :id="field.id" :class="field.cssClass + ' mt-1 p-2 w-full rounded-md bg-neutral'" :required="field.required" v-model="field.value" style="color: #333; !important;  background: white !important;">
                        <option disabled value="-1">-- select one element --</option>
                        
                        <optgroup v-if="field.grouped" v-for="(item, k) in field.items" :key="item.group" :label="item.group">
                            <option v-for="subitem in item.items" :key="subitem.value" :value="subitem.value" :selected="subitem.value === field.value" v-html="subitem.text"></option>
                        </optgroup>
                        <option v-else v-for="item in field.items" :key="item.value" :value="item.value" :selected="item.value === field.value" v-html="item.text"></option>
                    </select>
                    
                    <!--
                    <div v-if="field.type === 'select_image'" class="w-100 flex flex-row flex-wrap rounded-md" style="background-color: white !important;">
                        <div v-for="option in field.items" :key="field.value" @click="selectIcon(option.slug, fieldIndex)" :class="((field.value === option.slug) ? 'bg-primary rounded-md' : '') + ' flex-1'">
                            <img class="p-3 w-100" :src="option.iconUrl" height="auto" :title="option.name" :alt="option.name" />
                        </div>
                        <input :key="field.id + '_icon'" type="hidden" :id="field.id" :model="field.value" />
                    </div>
                    -->
                    <div v-if="field.type === 'select_image'" class="w-100 flex flex-col rounded-md" style="background-color: white !important;">
                        <div class="flex flex-wrap">
                            <div v-for="option in field.items" :key="field.value" @click="selectIcon(option.slug, fieldIndex)" :class="((field.value === option.slug) ? 'bg-primary rounded-md' : '') + ' p-2'">
                                <img class="w-100" :src="option.iconUrl" height="auto" :title="option.name" :alt="option.name" />
                            </div>
                        </div>
                        <input :key="field.id + '_icon'" type="hidden" :id="field.id" :model="field.value" />
                    </div>
                </div>
                <hr v-if="modalData.fields && ((modalData.fields.length > 1) || (modalData.fields.length == 1 && modalData.fields[0].type !== 'hidden'))" class="my-4" />
                <div class="modal-action flex justify-end">
                    <!-- form buttons -->
                    <button v-for="button in modalData.buttons" :key="button.text + '_btn'" :type="button.type" :class="button.cssClass + ' btn'" :disabled="!button.enabled" @click="emitEvent(button.onClick)" v-html="button.text"></button>
                </div>
            </form>
        </div>
    </dialog>
</template>

<!-- 
    Component Structure
    fields: [
        {
            type: 
                input -> text, number, checkbox, radio, date, time, datetime-local, color, file, range, search, tel, url, week, month, hidden
                select_textual
                select_image
            value: text
            items: [text, value] (in case of select)
            required: true, false
            label: text
            placeholder: text
            cssClass: text
            id: id
        }
    ],
    title
    text
    buttons: [
        {
            text: text
            cssClass: primary, secondary, success, danger, warning, info, light, dark, link
            onClick: function to trigger
            enabled: true|false
            type: submit
        }
    ],
    onSubmit: function to trigger
-->

<style>

</style>

<script>
export default {
    /**
     * @component Modal
     * @description A modal component that displays a dialog box with customizable fields, title, text, buttons, and submit action.
     * 
     * @prop {Object} modalData - The data to be displayed in the modal. It should have the following properties:
     *  - {String} id: The ID of the modal.
     *  - {Array} fields: An array of fields to be displayed in the modal. Each field object should have the following properties:
     *     - {String} label: The label for the field.
     *     - {String} type: The type of the field (e.g., text, number, email).
     *     - {String} value: The initial value of the field.
     *     - {Array} items: The items to be displayed in the field (in case of select).
     *     - {Boolean} required: Whether the field is required or not.
     *     - {String} placeholder: The placeholder text for the field.
     *     - {String} cssClass: The CSS class to be applied to the field.
     *     - {String} id: The ID of the field.
     * - {String} title: The title of the modal.
     * - {String} text: The text content of the modal.
     * - {Array} buttons: An array of buttons to be displayed in the modal. Each button object should have the following properties:
     *     - {String} text: The label for the button.
     *     - {String} type: The type of the button (e.g., primary, secondary).
     *     - {Boolean} enabled: Whether the button is enabled or not.
     *     - {Text} onClick: The function to be called in the parent component (using emits) when the button is clicked.
     *     - {Text] cssClass: The CSS class to be applied to the button.
     */
    props: {
        modalData: {
            type: Object,
            required: true,
            default: {}
        }
    },
    mounted() {
        console.log(this.modalData)
    },
    data() {
        return {
            icon: ""
        }
    },
    methods: {
        emitEvent(eventToEmit) {
            if(eventToEmit === "closeModal") {
                this.$emit('closeModal');
            } else {
                if(eventToEmit !== ""){
                    let checkIcon = this.modalData.fields.find((item) => item.type === "select_image")
                    if(((checkIcon && checkIcon.value !== "") || checkIcon == null)){
                        this.$emit(eventToEmit, this.modalData.fields.reduce((obj, item) => { obj[item.id] = item.value; return obj; }, {}))
                    } else {
                        this.$toast.warning("Please select an icon in the icon picker.")
                    }
                }
            }
            
        },
        selectIcon(icon, idx) {
            this.modalData.fields[idx].value = icon
        }
    }
};
</script>